﻿using System;
using Foundation;
using Syncfusion.SfChart.iOS;
using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.iOS;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using UIKit;
using Xamarin.Forms;
using Xamarin.Forms.Platform.iOS;
using Native = Syncfusion.SfChart.iOS;


 [assembly:ExportRenderer(typeof(SimpleSample.ChartExt), typeof(SimpleSample.iOS.CustomChartRenderer))]
namespace SimpleSample.iOS
{
	class CustomChartRenderer : SfChartRenderer
	{
		protected override void OnElementChanged(ElementChangedEventArgs<SfChart> e)
		{
			base.OnElementChanged(e);

			var formsChart = Element as Syncfusion.SfChart.XForms.SfChart;

			for (int i = 0; i < formsChart.ChartBehaviors.Count; i++)
			{
				if (formsChart.ChartBehaviors[i] is Syncfusion.SfChart.XForms.ChartTrackballBehavior)
				{
					var formsTrackball = formsChart.ChartBehaviors[i] as Syncfusion.SfChart.XForms.ChartTrackballBehavior;
					Control.Behaviors.Remove((SFChartBehavior)SfChartRenderer.GetNativeObject(typeof(Syncfusion.SfChart.XForms.ChartTrackballBehavior), formsTrackball));
					CustomTrackballBehavior customTrackball = new CustomTrackballBehavior();
					customTrackball.FormsBehavior = formsTrackball;

					var properties = SfChartRenderer.GetPropertiesChanged(typeof(Syncfusion.SfChart.XForms.ChartTrackballBehavior), formsTrackball);

					foreach (var name in properties)
					{
						ChartTrackballBehaviorMapping.OnChartTrackballBehaviorPropertiesChanged(name, formsTrackball, customTrackball);
					}

					SfChartRenderer.SetNativeObject(typeof(Syncfusion.SfChart.XForms.ChartTrackballBehavior), formsTrackball, customTrackball);
					Control.Behaviors.Insert(i, customTrackball);
				}
			}
		}
	}

	public class CustomTrackballBehavior : ChartTrackballBehaviorHelper
	{
		public override void LongPressWithGestureRecognizer(UILongPressGestureRecognizer longPressGestureRecognizer)
		{
			base.LongPressWithGestureRecognizer(longPressGestureRecognizer);

			var locationInChart = longPressGestureRecognizer.LocationInView(Chart);

			if (UIGestureRecognizerState.Ended == longPressGestureRecognizer.State)
			{
				(FormsBehavior as ChartTrackballBehaviorExt).TouchUp((float)locationInChart.X, (float)locationInChart.Y);
			}
		}
	}
}
